#ifndef _H_GLZ_DECODER_CONFIG
#define _H_GLZ_DECODER_CONFIG

#include <boost/format.hpp>
#include <exception>

#include "lz_common.h"

#include <stdio.h>

#ifdef __GNUC__

#include <stdint.h>


#else

#include <stddef.h>
#include <basetsd.h>


typedef UINT64 uint64_t;
typedef UINT32 uint32_t;
typedef UINT16 uint16_t;
typedef UINT8 uint8_t;

#endif	//__GNUC__

#define MIN(x, y) (((x) <= (y)) ? (x) : (y))
#define MAX(x, y) (((x) >= (y)) ? (x) : (y))

class GlzException : public std::exception {
public:
    GlzException(const std::string& str) : _mess(str) {}
    virtual ~GlzException() throw() {}
    virtual const char* what() const throw() {return _mess.c_str();}
private:
    std::string _mess;
};

class GlzDecoderDebug
{
public:
    virtual ~GlzDecoderDebug() {}
    virtual void error(const std::string& str) = 0;
    virtual void warn(const std::string& str)  = 0;
    virtual void info(const std::string& str)  = 0;
};

#ifdef DEBUG

#define GLZ_ASSERT(debug, x) \
    if (!(x)) (debug).error(str(boost::format("%s: ASSERT %s failed\n") % __FUNCTION__ % #x));

#else

#define GLZ_ASSERT(debug, x)

#endif

#define GLZ_DECODE_TO_RGB32

#endif	//_H_GLZ_DECODER_CONFIG
