#ifndef _H_PIXELS_SOURCE
#define _H_PIXELS_SOURCE

#include "draw.h"

#define PIXELES_SOURCE_OPAQUE_SIZE (20 * sizeof(void*))

class PixelsSource {
public:
    PixelsSource();
    virtual ~PixelsSource();

    virtual Point get_size() = 0;
    void set_origin(int x, int y) { _origin.x = x; _origin.y = y;}
    const Point& get_origin() { return _origin;}

protected:
    const uint8_t* get_opaque() const { return _opaque;}

private:
    Point _origin;
    uint8_t _opaque[PIXELES_SOURCE_OPAQUE_SIZE];

    friend class RedDrawable;
};

class ImageFromRes : public PixelsSource {
public:
    ImageFromRes(int res_id);
    virtual ~ImageFromRes();
    virtual Point get_size();
};

class AlphaImageFromRes : public PixelsSource {
public:
    AlphaImageFromRes(int res_id);
    virtual ~AlphaImageFromRes();
    virtual Point get_size();
};

#endif
