#ifndef _H_NAMED_PIPE
#define _H_NAMED_PIPE

#include <string.h>

#include "platform.h"
#include "xplatform.h"

class Session : public EventHandler
{
public:
    Session() {}
    virtual ~Session();
    int accept(int fd_client, int epoll);
    void bind(NamedPipe::ConnectionInterface* conn_interface);

public:
    void action(uint32_t events);
    int32_t write(const uint8_t *buf, int32_t size);
    int32_t read(uint8_t *buf, int32_t size);

private:
    NamedPipe::ConnectionInterface *_conn_interface;
    int _fd_client;
    int _epoll;
};

class LinuxListener : public EventHandler {
public:
    LinuxListener(const char *name, NamedPipe::ListenerInterface &listener_interface, int epoll);
    virtual ~LinuxListener();
    void action(uint32_t events);

private:
    int create_socket(const char *socket_name);

private:
    NamedPipe::ListenerInterface &_listener_interface;
    int _epoll;
    int _listen_socket;
    std::string _name; 
};


#endif
