#ifndef _H_PIXELE_SOURSR_P
#define _H_PIXELE_SOURSR_P

#define GL_GLEXT_PROTOTYPES
#include <X11/X.h>
#include <GL/glu.h>
#include <X11/extensions/XShm.h>
#include "red_window.h"
#include "red_pixmap_gl.h"
#include "cairo.h"

enum {
    PIXELS_SOURCE_TYPE_INVALID,
    PIXELS_SOURCE_TYPE_X_DRAWABLE,
    PIXELS_SOURCE_TYPE_XSHM_DRAWABLE,
    PIXELS_SOURCE_TYPE_PIXMAP,
    PIXELS_SOURCE_TYPE_GL_TEXTURE,
    PIXELS_SOURCE_TYPE_GL_DRAWABLE,
};

struct PixelsSource_p {
    int type;
    union {
        struct {
            Drawable drawable;
            GC gc;
            int width, height;
            RenderType rendertype;
            union {
                GLXPbuffer pbuff;
                GLuint fbo;
            };
            RedGlContext context;
        } x_drawable;

        struct {
            XImage* x_image;
            XShmSegmentInfo *shminfo;
            cairo_surface_t* cairo_surf; //not really needed
        } x_shm_drawable;
        
        struct {
            XImage* x_image;
            cairo_surface_t* cairo_surf;
        } pixmap;

        struct {
            RenderType rendertype;
            Win win;
            GLuint tex;
            GLuint stencil_tex;
            int width, height;
            int width_powed, height_powed;
            union {
                GLXPbuffer pbuff;
                GLuint fbo;
            };
            RedGlContext context;
        } gl;
    };
};

struct RedDrawable_p {
    PixelsSource_p source;
    union {
        cairo_t* cairo;
    };
};

#endif

