#ifndef _H_RED_WINDOW_P
#define _H_RED_WINDOW_P

#include <GL/glx.h>
#include <X11/Xlib.h>

typedef Window Win;
typedef GLXContext RedGlContext;
typedef GLXPbuffer RedPbuffer;

class RedWindow;
struct PixelsSource_p;

class RedWindow_p {
public:
    RedWindow_p();

    void migrate(RedWindow& red_window, PixelsSource_p& pix_source, int dest_screen);
    void create(RedWindow& red_window, PixelsSource_p& pix_source, int x, int y,
                unsigned int width, unsigned int height, int in_screen);
    void destroy(PixelsSource_p& pix_source);
    void set_minmax(PixelsSource_p& pix_source, int width, int height);
    void wait_for_reparent();
    void wait_for_map();
    void wait_for_unmap();
    void sync(bool shadowed = false);
    void set_visibale(bool vis) { _visibale = vis;}
    void move_to_current_desktop();

    static void win_proc(XEvent& event);
    static Cursor create_invisible_cursor(Window window);

    void set_glx(int width, int height);

protected:
    int _screen;
    Window _win;
    Cursor _invisible_cursor;
    bool _visibale;
    bool _expect_parent;
    Point _show_pos;
    GLXContext _glcont_copy;
    bool _focused;
    bool _ignore_foucs;
    bool _shadow_foucs_state;
    XEvent _shadow_focus_event;
    bool _pointer_in_window;
    bool _ignore_pointer;
    bool _shadow_pointer_state;
    XEvent _shadow_pointer_event;
    Colormap _colormap;
};

#endif

