#ifndef _H_XPLATFORM
#define _H_XPLATFORM

class EventHandler {
public:
    virtual void action(uint32_t events) = 0;
    virtual ~EventHandler() {}
};

class XPlatform {
public:
    static Display* get_display();
    static XVisualInfo** get_vinfo();
    static GLXFBConfig** get_fbconfig();
    
    typedef void (*win_proc_t)(XEvent& event);
    static void set_win_proc(Window win, win_proc_t proc);
    static void cleare_win_proc(Window win);
    static bool get_window_icon(int screen, Pixmap& pixmap, Pixmap& mask);
	static void on_focus_in();
	static void on_focus_out();
};

#endif

